﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;
using HeuristicLab.DataAccess;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.Hive.Contracts.BusinessObjects {

  // [chn] Where are those JobResults used? would it make sense to use it instead of JobDto for querying Job-Status? Probably yes
  // ask gradinger
  [StorableClass]
  [DataContract]
  [Serializable]
  public class JobResult : PersistableObject {
    [Storable]
    [DataMember]
    public Guid JobId { get; set; }
    [Storable]
    [DataMember]
    public Guid ClientId { get; set; }
    [Storable]
    [DataMember]
    public JobState State { get; set; }
    [Storable]
    [DataMember]
    public double? Percentage { get; set; }
    [Storable]
    [DataMember]
    public String Exception { get; set; }
    [Storable]
    [DataMember]
    public DateTime? DateCalculated { get; set; }
    [Storable]
    [DataMember]
    public DateTime? DateFinished { get; set; }

    public override Common.IDeepCloneable Clone(Common.Cloner cloner) {
      JobResult clone = (JobResult) base.Clone(cloner);
      clone.ClientId = this.ClientId;
      clone.DateCalculated = this.DateCalculated;
      clone.DateFinished = this.DateFinished;
      clone.Exception = this.Exception;
      clone.JobId = this.JobId;
      clone.Percentage = this.Percentage;
      clone.State = this.State;
      return clone;
    }
  }
}
