﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;
using System.IO;
using HeuristicLab.Hive.Contracts.BusinessObjects;
using HeuristicLab.Hive.Contracts.ResponseObjects;

namespace HeuristicLab.Hive.Contracts.Interfaces {
  [ServiceContract]
  public interface ISlaveFacade: ISlaveCommunicator {
    [OperationContract]
    Stream GetStreamedJob(Guid clientId);

    [OperationContract]
    Stream GetStreamedPlugins(List<HivePluginInfoDto> pluginList);

    [OperationContract]
    ResponseResultReceived StoreFinishedJobResultStreamed(Stream stream);

    [OperationContract]
    ResponseResultReceived ProcessSnapshotStreamed(Stream stream);
  }
}
