﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.Linq;

namespace HeuristicLab.Hive.Server.DataAccess {
  public interface IContextFactory {

    /// <summary>
    /// Uses transaction by default.
    /// The caller of this Method is resposible for disposing the Context!
    /// </summary>
    /// <returns></returns>
    IDisposable GetContext();

    IDisposable GetContext(bool withTransaction);

    DataContext CurrentContext { get; }

    void RollbackTransaction();

    void RemoveContext();

    void RemoveAndCompleteTransaction();
  }
}
