﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using HeuristicLab.Hive.Slave.Core.ClientConsoleService.Interfaces;
using HeuristicLab.Hive.Slave.Core.ConfigurationManager;
using HeuristicLab.Hive.Slave.Communication;
using HeuristicLab.Hive.Slave.Common;
using HeuristicLab.Hive.Contracts;
using HeuristicLab.Calendar;

namespace HeuristicLab.Hive.Slave.Core.ClientConsoleService {
  public class SlaveConsoleCommunicator: ISlaveConsoleCommunicator {
    #region IClientConsoleCommunicator Members

    public StatusCommons GetStatusInfos() {      
        return ConfigManager.Instance.GetStatusForClientConsole();
    }

    public void SetConnection(ConnectionContainer container) {
      ConfigManager.Instance.SetServerIPAndPort(container);
      WcfService.Instance.Connect(container.IPAdress, container.Port);
    }

    public void Disconnect() {
      WcfService.Instance.Disconnect();
    }   

    public ConnectionContainer GetCurrentConnection() {
      return new ConnectionContainer { IPAdress = WcfService.Instance.ServerIP, Port = WcfService.Instance.ServerPort };
    }

    public void ShutdownClient() {
      MessageQueue.GetInstance().AddMessage(MessageContainer.MessageType.Shutdown);
    }    

    public void SetUptimeCalendar(List<Appointment> appointments) {
      UptimeManager.Instance.SetAppointments(true, false, appointments);
    }

    public List<Appointment> GetUptimeCalendar() {
      return UptimeManager.Instance.AppContainer.Appointments;
    }

    #endregion
  }
}
